// AO

// This example introduces inheritance. Note that
// the Manager class is derived from the Employee class

// History: 3/29/24 - Introduced the keyword virtual. This allows functions to be overridden. Check
//                    out the Employee::calculatePay () function. We also introduced the "protected"
//                    access specifier. See the Employee attributes.
// 
//          3/27/24 - Added the inheritance syntax to class Manager so that it was derived
//                    from base class Employee. Implemented the constructor for Manager and
//                    a version of calculatePay () for Manager that considers the salarly 
//                    attribute. Declared an Employee and a Manager object in main ().
//

#include <iostream>
#include <string>

// Inheritance starter code! Not yet complete!

// #include <vector>

#include "Employee.hpp"
#include "Manager.hpp"

void printPay(Employee& empl); // analyze this function! we can now 

int main(void)
{
	Employee e1;
	Manager m1("Chuck", 5000, 5, true);

	// we should be able to treat Managers like Employees
	Employee* pEmpl = new Employee("Jeffry", 20.00, 80), 
		    * pMang = new Manager("Chuck", 5000, 5, true);

	pEmpl->getPayRate();
	pMang->getPayRate();

	//cout << "Employee allocated dynamically pay: " << pEmpl->calculatePay() << endl;
	//cout << "Manager allocated dynamically pay: " << pMang->calculatePay() << endl;
	//cout << "Manager m1: " << m1.calculatePay() << endl;

	printPay(*pEmpl); // we're getting closer to be able to apply programming in the general.
	printPay(*pMang);


	m1.calculatePay(); // calls the Manager's calculatePay () because the compiler bases it's decision 
	                   // on the object type

	//std::vector<int> v1;

	//v1.push_back(10);
	//v1.push_back(25);
	//v1.pop_back();

	return 0;
}

void printPay(Employee& empl)
{
	cout << empl.getName() << "'s pay: " << empl.calculatePay() << endl;

}